C                           DISCLAIMER
C
C   This file was generated by TAMC version 5.3.2
C
C   THE AUTHOR DOES NOT MAKE  ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES
C   ANY LEGAL LIABILITY OR  RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS,
C   OR USEFULNESS  OF ANY INFORMATION OR PROCESS  DISCLOSED, OR REPRESENTS
C   THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
C
C   THIS CODE IS FOR NON-PROFIT-ORIENTED ACADEMIC RESEARCH AND EDUCATION
C   ONLY.  ANY COMMERCIAL OR OTHER PROFIT-ORIENTED USE OR  EVALUATION IS
C   STRICTLY  FORBIDDEN.  PASSING  THIS CODE  TO  ANY THIRD  PARTY IS  NOT
C   ALLOWED.
C
C   FOR COMMERCIAL OR  OTHER PROFIT-ORIENTED APPLICATIONS PLEASE CONTACT
C   info@FastOpt.com
C
      subroutine hppm_ad( JDATE, JTIME, n, first_cell, last_cell, ori, dt, vel, con, con_ad )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.3.2    **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================

      USE HGRD_DEFN

      implicit none

C Includes:
      INCLUDE SUBST_IOPARMS     ! I/O parameters definitions

C==============================================
C define parameters                            
C==============================================
c$$$      real eps
c$$$      parameter ( eps = 0.01 )
c$$$      real eta1
c$$$      parameter ( eta1 = 20. )
c$$$      real eta2
c$$$      parameter ( eta2 = 0.05 )
c$$$      logical steepen
c$$$      parameter ( steepen =  .false.  )
c$$$      real two3rds
c$$$      parameter ( two3rds = 2./3. )
c$$$      real xcell_gd
c$$$      parameter ( xcell_gd = 4000. )
c$$$      integer xthik
c$$$      parameter ( xthik = 3 )
c$$$      real ycell_gd
c$$$      parameter ( ycell_gd = 4000. )
#ifdef parallel
      INTEGER, PARAMETER :: XTHIK = 3
#else
      INTEGER, PARAMETER :: XTHIK = 1
#endif

#ifdef STEEPEN_FLAG
      LOGICAL, PARAMETER :: STEEPEN = .TRUE. ! Flag for discontinuty capturing (steepening)
#else
      LOGICAL, PARAMETER :: STEEPEN = .FALSE.
#endif

      REAL, PARAMETER :: ETA1 = 20.0
      REAL, PARAMETER :: ETA2 = 0.05
      REAL, PARAMETER :: EPS = 0.01

      REAL, PARAMETER :: TWO3RDS = 2.0 / 3.0

c$$$C==============================================
c$$$C define common blocks
c$$$C==============================================
c$$$      common /hppmsv/ chi, ds, firstime, firstori, lambda, mu, nspcs, nu, pname, psi, sigma, tau, xmsg, zeta
c$$$      allocatable chi
c$$$      real chi(:)
c$$$      allocatable ds
c$$$      real ds(:)
c$$$      logical  :: firstime =  .true. 
c$$$      character  :: firstori = ' '
c$$$      allocatable lambda
c$$$      real lambda(:)
c$$$      allocatable mu
c$$$      real mu(:)
c$$$      integer nspcs
c$$$      allocatable nu
c$$$      real nu(:)
c$$$      character*(16)  :: pname = 'HPPM'
c$$$      allocatable psi
c$$$      real psi(:)
c$$$      allocatable sigma
c$$$      real sigma(:)
c$$$      allocatable tau
c$$$      real tau(:)
c$$$      character*(96)  :: xmsg = ' '
c$$$      allocatable zeta
c$$$      real zeta(:)

C "Special" Local Variables:
      CHARACTER, SAVE :: FIRSTORI = ' ' ! orientation flag (ORI)
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      CHARACTER(16) :: PNAME = 'HPPM_AD'
      CHARACTER(96) :: XMSG = ' '

      INTEGER :: ALLOCSTAT

      INTEGER, SAVE :: NSPCS    ! number of species
      INTEGER :: MXN            ! maximum value of N

      REAL, ALLOCATABLE, SAVE :: DS(:) ! distance between cell edges

C Saved lattice variables for processor's extended domain
      REAL, ALLOCATABLE, SAVE :: CHI   (:) ! lattice var. for DC
      REAL, ALLOCATABLE, SAVE :: PSI   (:) ! lattice var. for DC
      REAL, ALLOCATABLE, SAVE :: MU    (:) ! lattice var. for CM
      REAL, ALLOCATABLE, SAVE :: NU    (:) ! lattice var. for CM
      REAL, ALLOCATABLE, SAVE :: LAMBDA(:) ! lattice var. for CM

      REAL, ALLOCATABLE, SAVE :: ZETA  (:) ! lattice var. for ETABAR
      REAL, ALLOCATABLE, SAVE :: SIGMA (:) ! lattice var. for D2C
      REAL, ALLOCATABLE, SAVE :: TAU   (:) ! lattice var. for D2C

C==============================================
C define arguments
C==============================================
c$$$      integer n
c$$$      real con(1-xthik:n+xthik,:)
c$$$      real con_ad(1-xthik:n+xthik,:)
c$$$      real dt
c$$$      integer first_cell
c$$$      integer last_cell
c$$$      character ori
c$$$      real vel(1:n+1)
      INTEGER, INTENT(IN)   :: JDATE ! current model date, coded YYYYDDD
      INTEGER, INTENT(IN)   :: JTIME ! current model time, coded HHMMSS
      INTEGER, INTENT(IN)   :: N ! number of unknown concentrations
      INTEGER, INTENT(IN)   :: FIRST_CELL ! first cell of extended line inside global boundary
      INTEGER, INTENT(IN)   :: LAST_CELL ! last cell of extended line inside global boundary
      CHARACTER, INTENT(IN) :: ORI ! orientation of advection ('C'-x or 'R'-y)
      REAL, INTENT(IN)      :: DT ! time step
      REAL, INTENT(IN)      :: VEL(1:) ! velocities at cell edges (flux points)
      REAL, INTENT(INOUT)   :: CON(1-XTHIK:, 1:)
                                ! concentrations along the line
                                !   if FIRST_CELL=1, CON(0,:) holds boundary values
                                !   if LAST_CELL=N, CON(N+1,:) holds boundary values
      REAL, INTENT(INOUT)   :: CON_AD(1-XTHIK:, 1:)

C==============================================
C define local variables
C==============================================
      real a
      real alpha(2-xthik:n+xthik-1)
      real b
      real beta(2-xthik:n+xthik-1)
      real c
      real c6(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real c6_ad(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real cl(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real cl_ad(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real cld(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real cld_ad(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real cm(max(first_cell,0):min(last_cell,n+1)+1,1:size(con,2))
      real cm_ad(max(first_cell,0):min(last_cell,n+1)+1,1:size(con,2))
      real cr(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real cr_ad(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real crd(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real crd_ad(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real d
      real d2c(first_cell+1:last_cell-1,1:size(con,2))
      real d2c_ad(first_cell+1:last_cell-1,1:size(con,2))
      real dc(max(first_cell,0)-1:min(last_cell,n+1)+1,1:size(con,2))
      real dc_ad(max(first_cell,0)-1:min(last_cell,n+1)+1,1:size(con,2))
      real eta(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real eta_ad(max(first_cell,0):min(last_cell,n+1),1:size(con,2))
      real etabar
      real etabar_ad
      integer, save :: first_par
      integer, save :: first_std
      real fm_ad(1:n+1,1:size(con,2))
      real fp_ad(0:n,1:size(con,2))
      real gamma
      integer i
      integer, save :: last_par
      integer, save :: last_std
      integer s
      real x
      real y

C----------------------------------------------
C RESET LOCAL ADJOINT VARIABLES
C----------------------------------------------
      c6_ad(:,:) = 0.
      cl_ad(:,:) = 0.
      cld_ad(:,:) = 0.
      cm_ad(:,:) = 0.
      cr_ad(:,:) = 0.
      crd_ad(:,:) = 0.
      d2c_ad(:,:) = 0.
      dc_ad(:,:) = 0.
      eta_ad(:,:) = 0.
      etabar_ad = 0.
      fm_ad(:,:) = 0.
      fp_ad(:,:) = 0.

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
c$$$      if (firstime) then
c$$$        nspcs = size(con,2)
c$$$      endif
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         NSPCS = SIZE(CON, 2)
         MXN = MAX(NCOLS, NROWS)

         ALLOCATE(
     &        DS    (1-XTHIK : MXN+XTHIK),
     &        CHI   (2-XTHIK : MXN+XTHIK-1),
     &        PSI   (2-XTHIK : MXN+XTHIK-1),
     &        MU    (3-XTHIK : MXN+XTHIK-1),
     &        NU    (3-XTHIK : MXN+XTHIK-1),
     &        LAMBDA(3-XTHIK : MXN+XTHIK-1),
     &        STAT = ALLOCSTAT)
         IF ( ALLOCSTAT /= 0 ) THEN
            XMSG = 'Failure allocating lattice arrays'
            CALL M3EXIT(PNAME, JDATE, JTIME, XMSG, XSTAT1)
         END IF

         IF ( STEEPEN ) THEN
            ALLOCATE(
     &           ZETA (3-XTHIK : MXN+XTHIK-2),
     &           SIGMA(2-XTHIK : MXN+XTHIK-1),
     &           TAU  (2-XTHIK : MXN+XTHIK-1),
     &           STAT = ALLOCSTAT)
            IF ( ALLOCSTAT /= 0 ) THEN
               XMSG = 'Failure allocating steepening lattice arrays'
               CALL M3EXIT(PNAME, JDATE, JTIME, XMSG, XSTAT1)
            END IF
         END IF
      END IF                    ! FIRSTIME
      if (ori .ne. firstori) then
         FIRSTORI = ORI
        if (ori .eq. 'C') then
          ds(:) = xcell_gd
        else
          ds(:) = ycell_gd
        endif
        first_par = max(first_cell,0)
        last_par = min(last_cell,n+1)
        first_std = first_cell+2
        last_std = last_cell-2
        do i = first_std-1, last_std+1
          alpha(i) = ds(i)+ds(i+1)
          beta(i) = ds(i-1)+ds(i)
          d = ds(i)/(beta(i)+ds(i+1))
          chi(i) = d*(ds(i-1)+beta(i))/alpha(i)
          psi(i) = d*(alpha(i)+ds(i+1))/beta(i)
        end do
        do i = first_std, last_std+1
          gamma = ds(i-2)+ds(i-1)
          a = ds(i-1)/beta(i)
          b = 2.*ds(i)/beta(i)
          c = 1./(alpha(i)+gamma)
          mu(i) = c*ds(i-1)*gamma/(ds(i-1)+beta(i))
          nu(i) = c*ds(i)*alpha(i)/(ds(i)+beta(i))
          lambda(i) = a+mu(i)*b-2.*nu(i)*a
        end do
        if (steepen) then
          do i = first_std, last_std
            zeta(i) = 0.25*(alpha(i)*alpha(i)-alpha(i)*beta(i)+beta(i)*beta(i))
          end do
          do i = first_std-1, last_std+1
            c = 1./(beta(i)+ds(i+1))
            sigma(i) = c/alpha(i)
            tau(i) = c/beta(i)
          end do
        endif
      endif
      do s = 1, nspcs
        do i = first_std-1, last_std+1
          dc(i,s) = chi(i)*(con(i+1,s)-con(i,s))+psi(i)*(con(i,s)-con(i-1,s))
          if ((con(i+1,s)-con(i,s))*(con(i,s)-con(i-1,s)) .gt. 0.) then
            dc(i,s) = sign(1.,dc(i,s))*min(abs(dc(i,s)),2.*abs(con(i+1,s)-con(i,s)),2.*abs(con(i,s)-con(i-1,s)))
          else
            dc(i,s) = 0.
          endif
        end do
      end do
      if (first_cell .eq. 1) then
        i = first_std-2
        do s = 1, nspcs
          if (i .ge. first_par) then
            cm(i,s) = con(i,s)
          endif
          cm(i+1,s) = (ds(i)*con(i+1,s)+ds(i+1)*con(i,s))/(ds(i)+ds(i+1))
        end do
      endif
      if (last_cell .eq. n) then
        i = last_std+2
        do s = 1, nspcs
          if (i .le. last_par) then
            cm(i+1,s) = con(i,s)
          endif
          cm(i,s) = (ds(i-1)*con(i,s)+ds(i)*con(i-1,s))/(ds(i-1)+ds(i))
        end do
      endif
      do s = 1, nspcs
        do i = first_std, last_std+1
          cm(i,s) = con(i-1,s)+lambda(i)*(con(i,s)-con(i-1,s))-mu(i)*dc(i,s)+nu(i)*dc(i-1,s)
        end do
        do i = first_par, last_par
          eta(i,s) = 0.
          cld(i,s) = con(i,s)
          crd(i,s) = con(i,s)
        end do
      end do
      if (steepen) then
        do s = 1, nspcs
          do i = first_std-1, last_std+1
            d2c(i,s) = sigma(i)*(con(i+1,s)-con(i,s))-tau(i)*(con(i,s)-con(i-1,s))
          end do
        end do
        do s = 1, nspcs
          do i = first_std, last_std
            if ((-(d2c(i+1,s)*d2c(i-1,s))) .gt. 0. .and. abs(con(i+1,s)-con(i-1,s))-eps*min(abs(con(i+1,s)),abs(con(i-1,s))) .gt. 
     $0.) then
              etabar = -(zeta(i)*(d2c(i+1,s)-d2c(i-1,s))/(con(i+1,s)-con(i-1,s)))
            else
              etabar = 0.
            endif
            eta(i,s) = max(0.,min(eta1*(etabar-eta2),1.))
            crd(i,s) = con(i+1,s)-0.5*dc(i+1,s)
            cld(i,s) = con(i-1,s)+0.5*dc(i-1,s)
          end do
        end do
      endif
      do s = 1, nspcs
        do i = 1, n
          fm_ad(i+1,s) = fm_ad(i+1,s)+con_ad(i,s)/ds(i)
          fm_ad(i,s) = fm_ad(i,s)-con_ad(i,s)/ds(i)
          fp_ad(i-1,s) = fp_ad(i-1,s)+con_ad(i,s)/ds(i)
          fp_ad(i,s) = fp_ad(i,s)-con_ad(i,s)/ds(i)
        end do
      end do
      if (last_par .eq. n) then
        i = n+1
        if (vel(i) .lt. 0.) then
          y = -(vel(i)*dt)
          do s = 1, nspcs
            con_ad(i,s) = con_ad(i,s)+fm_ad(i,s)*y
            fm_ad(i,s) = 0.
          end do
        endif
      endif
      if (first_par .eq. 1) then
        if (vel(1) .gt. 0.) then
          y = vel(1)*dt
          do s = 1, nspcs
            con_ad(0,s) = con_ad(0,s)+fp_ad(0,s)*y
            fp_ad(0,s) = 0.
          end do
        endif
      endif
      do s = nspcs, 1, -1
        i = n+1
        if (last_par .ge. i .and. vel(i) .lt. 0.) then
          y = -(vel(i)*dt)
          x = y/ds(i)
          c6_ad(i,s) = c6_ad(i,s)+0.5*fm_ad(i,s)*y*x*(1.-two3rds*x)
          cl_ad(i,s) = cl_ad(i,s)+fm_ad(i,s)*y
          dc_ad(i,s) = dc_ad(i,s)+0.5*fm_ad(i,s)*y*x
          fm_ad(i,s) = 0.
        endif
        do i = n, 1, -1
          if (vel(i+1) .gt. 0.) then
            y = vel(i+1)*dt
            x = y/ds(i)
            c6_ad(i,s) = c6_ad(i,s)+0.5*fp_ad(i,s)*y*x*(1.-two3rds*x)
            cr_ad(i,s) = cr_ad(i,s)+fp_ad(i,s)*y
            dc_ad(i,s) = dc_ad(i,s)-0.5*fp_ad(i,s)*y*x
            fp_ad(i,s) = 0.
          endif
          if (vel(i) .lt. 0.) then
            y = -(vel(i)*dt)
            x = y/ds(i)
            c6_ad(i,s) = c6_ad(i,s)+0.5*fm_ad(i,s)*y*x*(1.-two3rds*x)
            cl_ad(i,s) = cl_ad(i,s)+fm_ad(i,s)*y
            dc_ad(i,s) = dc_ad(i,s)+0.5*fm_ad(i,s)*y*x
            fm_ad(i,s) = 0.
          endif
        end do
        if (first_par .le. 0 .and. vel(1) .gt. 0.) then
          y = vel(1)*dt
          x = y/ds(0)
          c6_ad(0,s) = c6_ad(0,s)+0.5*fp_ad(0,s)*y*x*(1.-two3rds*x)
          cr_ad(0,s) = cr_ad(0,s)+fp_ad(0,s)*y
          dc_ad(0,s) = dc_ad(0,s)-0.5*fp_ad(0,s)*y*x
          fp_ad(0,s) = 0.
        endif
        do i = first_par, last_par
          cr(i,s) = cm(i+1,s)+eta(i,s)*(crd(i,s)-cm(i+1,s))
          cl(i,s) = cm(i,s)+eta(i,s)*(cld(i,s)-cm(i,s))
          cl_ad(i,s) = cl_ad(i,s)-3*c6_ad(i,s)
          con_ad(i,s) = con_ad(i,s)+6*c6_ad(i,s)
          cr_ad(i,s) = cr_ad(i,s)-3*c6_ad(i,s)
          c6_ad(i,s) = 0.
          cl_ad(i,s) = cl_ad(i,s)-dc_ad(i,s)
          cr_ad(i,s) = cr_ad(i,s)+dc_ad(i,s)
          dc_ad(i,s) = 0.
          if ((cr(i,s)-con(i,s))*(con(i,s)-cl(i,s)) .gt. 0.) then
            dc(i,s) = cr(i,s)-cl(i,s)
            c6(i,s) = 6.*(con(i,s)-0.5*(cl(i,s)+cr(i,s)))
            if (dc(i,s)*c6(i,s) .gt. dc(i,s)*dc(i,s)) then
              con_ad(i,s) = con_ad(i,s)+3*cl_ad(i,s)
              cr_ad(i,s) = cr_ad(i,s)-2*cl_ad(i,s)
              cl_ad(i,s) = 0.
            else if ((-(dc(i,s)*dc(i,s))) .gt. dc(i,s)*c6(i,s)) then
              cl_ad(i,s) = cl_ad(i,s)-2*cr_ad(i,s)
              con_ad(i,s) = con_ad(i,s)+3*cr_ad(i,s)
              cr_ad(i,s) = 0.
            endif
            cl_ad(i,s) = cl_ad(i,s)-3*c6_ad(i,s)
            con_ad(i,s) = con_ad(i,s)+6*c6_ad(i,s)
            cr_ad(i,s) = cr_ad(i,s)-3*c6_ad(i,s)
            c6_ad(i,s) = 0.
            cl_ad(i,s) = cl_ad(i,s)-dc_ad(i,s)
            cr_ad(i,s) = cr_ad(i,s)+dc_ad(i,s)
            dc_ad(i,s) = 0.
          else
            con_ad(i,s) = con_ad(i,s)+cr_ad(i,s)
            cr_ad(i,s) = 0.
            con_ad(i,s) = con_ad(i,s)+cl_ad(i,s)
            cl_ad(i,s) = 0.
          endif
          cld_ad(i,s) = cld_ad(i,s)+cl_ad(i,s)*eta(i,s)
          cm_ad(i,s) = cm_ad(i,s)+cl_ad(i,s)*(1-eta(i,s))
          eta_ad(i,s) = eta_ad(i,s)+cl_ad(i,s)*(cld(i,s)-cm(i,s))
          cl_ad(i,s) = 0.
          cm_ad(i+1,s) = cm_ad(i+1,s)+cr_ad(i,s)*(1-eta(i,s))
          crd_ad(i,s) = crd_ad(i,s)+cr_ad(i,s)*eta(i,s)
          eta_ad(i,s) = eta_ad(i,s)+cr_ad(i,s)*(crd(i,s)-cm(i+1,s))
          cr_ad(i,s) = 0.
        end do
      end do
      if (steepen) then
        do s = 1, nspcs
          etabar_ad = 0.
          do i = first_std, last_std
            etabar_ad = 0.
            if ((-(d2c(i+1,s)*d2c(i-1,s))) .gt. 0. .and. abs(con(i+1,s)-con(i-1,s))-eps*min(abs(con(i+1,s)),abs(con(i-1,s))) .gt. 
     $0.) then
              etabar = -(zeta(i)*(d2c(i+1,s)-d2c(i-1,s))/(con(i+1,s)-con(i-1,s)))
            else
              etabar = 0.
            endif
            con_ad(i-1,s) = con_ad(i-1,s)+cld_ad(i,s)
            dc_ad(i-1,s) = dc_ad(i-1,s)+0.5*cld_ad(i,s)
            cld_ad(i,s) = 0.
            con_ad(i+1,s) = con_ad(i+1,s)+crd_ad(i,s)
            dc_ad(i+1,s) = dc_ad(i+1,s)-0.5*crd_ad(i,s)
            crd_ad(i,s) = 0.
            etabar_ad = etabar_ad+eta_ad(i,s)*(0.5-sign(0.5,0.-min(eta1*(etabar-eta2),1.)))*(0.5+sign(0.5,1.-eta1*(etabar-eta2)))*
     $eta1
            eta_ad(i,s) = 0.
            if ((-(d2c(i+1,s)*d2c(i-1,s))) .gt. 0. .and. abs(con(i+1,s)-con(i-1,s))-eps*min(abs(con(i+1,s)),abs(con(i-1,s))) .gt. 
     $0.) then
              con_ad(i-1,s) = con_ad(i-1,s)-etabar_ad*(zeta(i)*(d2c(i+1,s)-d2c(i-1,s))/((con(i+1,s)-con(i-1,s))*(con(i+1,s)-con(i-1,
     $s))))
              con_ad(i+1,s) = con_ad(i+1,s)+etabar_ad*(zeta(i)*(d2c(i+1,s)-d2c(i-1,s))/((con(i+1,s)-con(i-1,s))*(con(i+1,s)-con(i-1,
     $s))))
              d2c_ad(i-1,s) = d2c_ad(i-1,s)+etabar_ad*(zeta(i)/(con(i+1,s)-con(i-1,s)))
              d2c_ad(i+1,s) = d2c_ad(i+1,s)-etabar_ad*(zeta(i)/(con(i+1,s)-con(i-1,s)))
              etabar_ad = 0.
            else
              etabar_ad = 0.
            endif
          end do
        end do
        do s = 1, nspcs
          do i = first_std-1, last_std+1
            con_ad(i-1,s) = con_ad(i-1,s)+d2c_ad(i,s)*tau(i)
            con_ad(i+1,s) = con_ad(i+1,s)+d2c_ad(i,s)*sigma(i)
            con_ad(i,s) = con_ad(i,s)-d2c_ad(i,s)*(sigma(i)+tau(i))
            d2c_ad(i,s) = 0.
          end do
        end do
      endif
      do s = 1, nspcs
        do i = first_par, last_par
          con_ad(i,s) = con_ad(i,s)+crd_ad(i,s)
          crd_ad(i,s) = 0.
          con_ad(i,s) = con_ad(i,s)+cld_ad(i,s)
          cld_ad(i,s) = 0.
        end do
        do i = first_std, last_std+1
          con_ad(i-1,s) = con_ad(i-1,s)+cm_ad(i,s)*(1-lambda(i))
          con_ad(i,s) = con_ad(i,s)+cm_ad(i,s)*lambda(i)
          dc_ad(i-1,s) = dc_ad(i-1,s)+cm_ad(i,s)*nu(i)
          dc_ad(i,s) = dc_ad(i,s)-cm_ad(i,s)*mu(i)
          cm_ad(i,s) = 0.
        end do
      end do
      if (last_cell .eq. n) then
        do s = 1, nspcs
          con_ad(i-1,s) = con_ad(i-1,s)+cm_ad(i,s)*(ds(i)/(ds(i-1)+ds(i)))
          con_ad(i,s) = con_ad(i,s)+cm_ad(i,s)*(ds(i-1)/(ds(i-1)+ds(i)))
          cm_ad(i,s) = 0.
          if (i .le. last_par) then
            con_ad(i,s) = con_ad(i,s)+cm_ad(i+1,s)
            cm_ad(i+1,s) = 0.
          endif
        end do
      endif
      if (first_cell .eq. 1) then
        do s = 1, nspcs
          con_ad(i+1,s) = con_ad(i+1,s)+cm_ad(i+1,s)*(ds(i)/(ds(i)+ds(i+1)))
          con_ad(i,s) = con_ad(i,s)+cm_ad(i+1,s)*(ds(i+1)/(ds(i)+ds(i+1)))
          cm_ad(i+1,s) = 0.
          if (i .ge. first_par) then
            con_ad(i,s) = con_ad(i,s)+cm_ad(i,s)
            cm_ad(i,s) = 0.
          endif
        end do
      endif
      do s = 1, nspcs
        do i = first_std-1, last_std+1
          dc(i,s) = chi(i)*(con(i+1,s)-con(i,s))+psi(i)*(con(i,s)-con(i-1,s))
          if ((con(i+1,s)-con(i,s))*(con(i,s)-con(i-1,s)) .gt. 0.) then
            con_ad(i+1,s) = con_ad(i+1,s)+2.*dc_ad(i,s)*(0.5-sign(0.5,2.*abs(con(i+1,s)-con(i,s))-abs(dc(i,s))))*sign(1.,con(i+1,s)-
     $con(i,s))*sign(1.,dc(i,s))
            con_ad(i,s) = con_ad(i,s)-2.*dc_ad(i,s)*(0.5-sign(0.5,2.*abs(con(i+1,s)-con(i,s))-abs(dc(i,s))))*sign(1.,con(i+1,s)-
     $con(i,s))*sign(1.,dc(i,s))
            dc_ad(i,s) = dc_ad(i,s)*(0.5+sign(0.5,2.*abs(con(i+1,s)-con(i,s))-abs(dc(i,s))))*sign(1.,dc(i,s))*sign(1.,dc(i,s))
          else
            dc_ad(i,s) = 0.
          endif
          con_ad(i-1,s) = con_ad(i-1,s)-dc_ad(i,s)*psi(i)
          con_ad(i+1,s) = con_ad(i+1,s)+dc_ad(i,s)*chi(i)
          con_ad(i,s) = con_ad(i,s)+dc_ad(i,s)*((-chi(i))+psi(i))
          dc_ad(i,s) = 0.
        end do
      end do

      end subroutine hppm_ad


