C                           DISCLAIMER
C
C   This file was generated by TAMC version 5.3.2
C
C   THE AUTHOR DOES NOT MAKE  ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES
C   ANY LEGAL LIABILITY OR  RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS,
C   OR USEFULNESS  OF ANY INFORMATION OR PROCESS  DISCLOSED, OR REPRESENTS
C   THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
C
C   THIS CODE IS FOR NON-PROFIT-ORIENTED ACADEMIC RESEARCH AND EDUCATION
C   ONLY.  ANY COMMERCIAL OR OTHER PROFIT-ORIENTED USE OR  EVALUATION IS
C   STRICTLY  FORBIDDEN.  PASSING  THIS CODE  TO  ANY THIRD  PARTY IS  NOT
C   ALLOWED.
C
C   FOR COMMERCIAL OR  OTHER PROFIT-ORIENTED APPLICATIONS PLEASE CONTACT
C   info@FastOpt.com
C
      subroutine vppm_ad( ni, con, vel, dt, ds, con_ad )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.3.2    **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C Includes:
      INCLUDE SUBST_IOPARMS     ! I/O parameters definitions

C==============================================
C define parameters                            
C==============================================
c$$$      real eps
c$$$      parameter ( eps = 0.01 )
c$$$      real eta1
c$$$      parameter ( eta1 = 20. )
c$$$      real eta2
c$$$      parameter ( eta2 = 1./eta1 )
c$$$      logical steepen
c$$$      parameter ( steepen =  .true.  )
c$$$      real two3rds
c$$$      parameter ( two3rds = 2./3. )
      LOGICAL, PARAMETER :: STEEPEN = .TRUE. ! Flag for discontinuty capturing (steepening)
      REAL, PARAMETER :: ETA1 = 20.0
      REAL, PARAMETER :: ETA2 = 1.0 / ETA1
      REAL, PARAMETER :: EPS = 0.01

      REAL, PARAMETER :: TWO3RDS = 2.0 / 3.0

c$$$C==============================================
c$$$C define common blocks
c$$$C==============================================
c$$$      common /vppmsv/ chi, firstime, lambda, mu, nu, psi, sigma, tau, xmsg, zeta
c$$$      allocatable chi
c$$$      real chi(:)
c$$$      logical  :: firstime =  .true. 
c$$$      allocatable lambda
c$$$      real lambda(:)
c$$$      allocatable mu
c$$$      real mu(:)
c$$$      allocatable nu
c$$$      real nu(:)
c$$$      allocatable psi
c$$$      real psi(:)
c$$$      allocatable sigma
c$$$      real sigma(:)
c$$$      allocatable tau
c$$$      real tau(:)
c$$$      character*(120)  :: xmsg = ' '
c$$$      allocatable zeta
c$$$      real zeta(:)

C "Special" Local Variables:
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 120 ) :: XMSG = ' '

      REAL, ALLOCATABLE, SAVE :: MU( : ) ! lattice var. for CM
      REAL, ALLOCATABLE, SAVE :: NU    ( : ) ! lattice var. for CM
      REAL, ALLOCATABLE, SAVE :: LAMBDA( : ) ! lattice var. for CM
      REAL, ALLOCATABLE, SAVE :: CHI   ( : ) ! lattice var. for DC
      REAL, ALLOCATABLE, SAVE :: PSI   ( : ) ! lattice var. for DC
      REAL, ALLOCATABLE, SAVE :: ZETA  ( : ) ! lattice var. for ETABAR
      REAL, ALLOCATABLE, SAVE :: SIGMA ( : ) ! lattice var. for D2C
      REAL, ALLOCATABLE, SAVE :: TAU   ( : ) ! lattice var. for D2C

      INTEGER :: ALLOCSTAT

C==============================================
C define arguments
C==============================================
c$$$      integer ni
c$$$      real con(ni)
c$$$      real con_ad(ni)
c$$$      real ds(ni)
c$$$      real dt
c$$$      real vel(ni)
      INTEGER, INTENT(IN) :: NI ! number of zones (cells)
      REAL, INTENT(IN) :: CON( NI ) ! concentrations in a vertical column
      REAL, INTENT(IN) :: VEL( NI ) ! velocities at zone (cell) boundaries
      REAL, INTENT(IN) :: DS ( NI ) ! distance between zone (cell) boundaries
      REAL, INTENT(IN) :: DT    ! time step
      REAL, INTENT(INOUT) :: CON_AD( NI ) ! sensitivities in a vertical column

C==============================================
C define local variables
C==============================================
      real a
      real alpha(ni+1)
      real b
      real beta(ni+1)
      real c
      real c6(ni+1)
      real c6_ad(ni+1)
      real cl(ni+1)
      real cl_ad(ni+1)
      real cld(ni+1)
      real cld_ad(ni+1)
      real cm(0:ni+1)
      real cm_ad(0:ni+1)
      real cr(ni+1)
      real cr_ad(ni+1)
      real crd(ni+1)
      real crd_ad(ni+1)
      real d2c(ni+1)
      real d2c_ad(ni+1)
      real dc(ni+1)
      real dc_ad(ni+1)
      real eta(ni+1)
      real eta_ad(ni+1)
      real etabar(ni+1)
      real etabar_ad(ni+1)
      real fm_ad(0:ni+1)
      real fp_ad(0:ni+1)
      integer i
      real x
      real y

C----------------------------------------------
C RESET LOCAL ADJOINT VARIABLES
C----------------------------------------------
      c6_ad(:) = 0.
      cl_ad(:) = 0.
      cld_ad(:) = 0.
      cm_ad(:) = 0.
      cr_ad(:) = 0.
      crd_ad(:) = 0.
      d2c_ad(:) = 0.
      dc_ad(:) = 0.
      eta_ad(:) = 0.
      etabar_ad(:) = 0.
      fm_ad(:) = 0.
      fp_ad(:) = 0.

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
      if (firstime) then
         FIRSTIME = .FALSE.

         ALLOCATE ( MU    ( NI+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( NU    ( NI+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( LAMBDA( NI+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( CHI   ( NI+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( PSI   ( NI+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( ZETA  ( NI+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( SIGMA ( NI+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( TAU   ( NI+1 ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating '
     &           // 'MU, NU, LAMBDA, CHI, PSI, ZETA, SIGMA, or TAU'
            CALL M3EXIT( 'VPPM', 0, 0, XMSG, XSTAT1 )
         END IF

        do i = 2, ni-1
          alpha(i) = ds(i)+ds(i+1)
          beta(i) = ds(i-1)+ds(i)
          c = ds(i)/(beta(i)+ds(i+1))
          chi(i) = c*(ds(i-1)+beta(i))/alpha(i)
          psi(i) = c*(alpha(i)+ds(i+1))/beta(i)
        end do
        do i = 2, ni-2
          a = ds(i)/alpha(i)
          b = 2.*ds(i+1)/alpha(i)
          c = 1./(ds(i-1)+alpha(i)+ds(i+2))
          mu(i) = c*ds(i)*(ds(i-1)+ds(i))/(ds(i)+alpha(i))
          nu(i) = c*ds(i+1)*(ds(i+1)+ds(i+2))/(ds(i+1)+alpha(i))
          lambda(i) = a+mu(i)*b-2.*nu(i)*a
        end do
        if (steepen) then
          do i = 2, ni-1
            c = 1./(beta(i)+ds(i+1))
            sigma(i) = c/alpha(i)
            tau(i) = c/beta(i)
            zeta(i) = 0.25*(alpha(i)*alpha(i)-alpha(i)*beta(i)+beta(i)*beta(i))
          end do
        endif
      endif
      cm(1) = con(1)
      cm(ni+1) = con(ni)
      cm(2) = (ds(1)*con(2)+ds(2)*con(1))/(ds(1)+ds(2))
      cm(ni) = (ds(ni-1)*con(ni)+ds(ni)*con(ni-1))/(ds(ni-1)+ds(ni))
      do i = 2, ni-1
        dc(i) = chi(i)*(con(i+1)-con(i))+psi(i)*(con(i)-con(i-1))
        if ((con(i+1)-con(i))*(con(i)-con(i-1)) .gt. 0.) then
          dc(i) = sign(1.,dc(i))*min(abs(dc(i)),2.*abs(con(i+1)-con(i)),2.*abs(con(i)-con(i-1)))
        else
          dc(i) = 0.
        endif
      end do
      do i = 2, ni-2
        cm(i+1) = con(i)+lambda(i)*(con(i+1)-con(i))-mu(i)*dc(i+1)+nu(i)*dc(i)
      end do
      do i = 1, ni
        eta(i) = 0.
        cld(i) = con(i)
        crd(i) = con(i)
      end do
      if (steepen) then
        do i = 2, ni-1
          d2c(i) = sigma(i)*(con(i+1)-con(i))-tau(i)*(con(i)-con(i-1))
        end do
        do i = 3, ni-2
          if ((-(d2c(i+1)*d2c(i-1))) .gt. 0. .and. abs(con(i+1)-con(i-1))-eps*min(abs(con(i+1)),abs(con(i-1))) .gt. 0.) then
            etabar(i) = -(zeta(i)*(d2c(i+1)-d2c(i-1))/(con(i+1)-con(i-1)))
          else
            etabar(i) = 0.
          endif
          eta(i) = max(0.,min(eta1*(etabar(i)-eta2),1.))
          crd(i) = con(i+1)-0.5*dc(i+1)
          cld(i) = con(i-1)+0.5*dc(i-1)
        end do
      endif
      do i = 1, ni
        fm_ad(i+1) = fm_ad(i+1)+con_ad(i)/ds(i)
        fm_ad(i) = fm_ad(i)-con_ad(i)/ds(i)
        fp_ad(i-1) = fp_ad(i-1)+con_ad(i)/ds(i)
        fp_ad(i) = fp_ad(i)-con_ad(i)/ds(i)
      end do
      do i = 1, ni-1
        if (vel(i+1) .gt. 0.) then
          y = vel(i+1)*dt
          x = y/ds(i)
          c6_ad(i) = c6_ad(i)+0.5*fp_ad(i)*y*x*(1.-two3rds*x)
          cr_ad(i) = cr_ad(i)+fp_ad(i)*y
          dc_ad(i) = dc_ad(i)-0.5*fp_ad(i)*y*x
          fp_ad(i) = 0.
        endif
      end do
      do i = 1, ni
        if (vel(i) .lt. 0.) then
          y = -(vel(i)*dt)
          x = y/ds(i)
          c6_ad(i) = c6_ad(i)+0.5*fm_ad(i)*y*x*(1.-two3rds*x)
          cl_ad(i) = cl_ad(i)+fm_ad(i)*y
          dc_ad(i) = dc_ad(i)+0.5*fm_ad(i)*y*x
          fm_ad(i) = 0.
        endif
      end do
      do i = 1, ni
        cr(i) = cm(i+1)+eta(i)*(crd(i)-cm(i+1))
        cl(i) = cm(i)+eta(i)*(cld(i)-cm(i))
        cl_ad(i) = cl_ad(i)-3*c6_ad(i)
        con_ad(i) = con_ad(i)+6*c6_ad(i)
        cr_ad(i) = cr_ad(i)-3*c6_ad(i)
        c6_ad(i) = 0.
        cl_ad(i) = cl_ad(i)-dc_ad(i)
        cr_ad(i) = cr_ad(i)+dc_ad(i)
        dc_ad(i) = 0.
        if ((cr(i)-con(i))*(con(i)-cl(i)) .gt. 0.) then
          dc(i) = cr(i)-cl(i)
          c6(i) = 6.*(con(i)-0.5*(cl(i)+cr(i)))
          if (dc(i)*c6(i) .gt. dc(i)*dc(i)) then
            con_ad(i) = con_ad(i)+3*cl_ad(i)
            cr_ad(i) = cr_ad(i)-2*cl_ad(i)
            cl_ad(i) = 0.
          else if ((-(dc(i)*dc(i))) .gt. dc(i)*c6(i)) then
            cl_ad(i) = cl_ad(i)-2*cr_ad(i)
            con_ad(i) = con_ad(i)+3*cr_ad(i)
            cr_ad(i) = 0.
          endif
          cl_ad(i) = cl_ad(i)-3*c6_ad(i)
          con_ad(i) = con_ad(i)+6*c6_ad(i)
          cr_ad(i) = cr_ad(i)-3*c6_ad(i)
          c6_ad(i) = 0.
          cl_ad(i) = cl_ad(i)-dc_ad(i)
          cr_ad(i) = cr_ad(i)+dc_ad(i)
          dc_ad(i) = 0.
        else
          con_ad(i) = con_ad(i)+cr_ad(i)
          cr_ad(i) = 0.
          con_ad(i) = con_ad(i)+cl_ad(i)
          cl_ad(i) = 0.
        endif
        cld_ad(i) = cld_ad(i)+cl_ad(i)*eta(i)
        cm_ad(i) = cm_ad(i)+cl_ad(i)*(1-eta(i))
        eta_ad(i) = eta_ad(i)+cl_ad(i)*(cld(i)-cm(i))
        cl_ad(i) = 0.
        cm_ad(i+1) = cm_ad(i+1)+cr_ad(i)*(1-eta(i))
        crd_ad(i) = crd_ad(i)+cr_ad(i)*eta(i)
        eta_ad(i) = eta_ad(i)+cr_ad(i)*(crd(i)-cm(i+1))
        cr_ad(i) = 0.
      end do
      if (steepen) then
        do i = 3, ni-2
          if ((-(d2c(i+1)*d2c(i-1))) .gt. 0. .and. abs(con(i+1)-con(i-1))-eps*min(abs(con(i+1)),abs(con(i-1))) .gt. 0.) then
            etabar(i) = -(zeta(i)*(d2c(i+1)-d2c(i-1))/(con(i+1)-con(i-1)))
          else
            etabar(i) = 0.
          endif
          con_ad(i-1) = con_ad(i-1)+cld_ad(i)
          dc_ad(i-1) = dc_ad(i-1)+0.5*cld_ad(i)
          cld_ad(i) = 0.
          con_ad(i+1) = con_ad(i+1)+crd_ad(i)
          dc_ad(i+1) = dc_ad(i+1)-0.5*crd_ad(i)
          crd_ad(i) = 0.
          etabar_ad(i) = etabar_ad(i)+eta_ad(i)*(0.5-sign(0.5,0.-min(eta1*(etabar(i)-eta2),1.)))*(0.5+sign(0.5,1.-eta1*(etabar(i)-
     $eta2)))*eta1
          eta_ad(i) = 0.
          if ((-(d2c(i+1)*d2c(i-1))) .gt. 0. .and. abs(con(i+1)-con(i-1))-eps*min(abs(con(i+1)),abs(con(i-1))) .gt. 0.) then
            con_ad(i-1) = con_ad(i-1)-etabar_ad(i)*(zeta(i)*(d2c(i+1)-d2c(i-1))/((con(i+1)-con(i-1))*(con(i+1)-con(i-1))))
            con_ad(i+1) = con_ad(i+1)+etabar_ad(i)*(zeta(i)*(d2c(i+1)-d2c(i-1))/((con(i+1)-con(i-1))*(con(i+1)-con(i-1))))
            d2c_ad(i-1) = d2c_ad(i-1)+etabar_ad(i)*(zeta(i)/(con(i+1)-con(i-1)))
            d2c_ad(i+1) = d2c_ad(i+1)-etabar_ad(i)*(zeta(i)/(con(i+1)-con(i-1)))
            etabar_ad(i) = 0.
          else
            etabar_ad(i) = 0.
          endif
        end do
        do i = 2, ni-1
          con_ad(i-1) = con_ad(i-1)+d2c_ad(i)*tau(i)
          con_ad(i+1) = con_ad(i+1)+d2c_ad(i)*sigma(i)
          con_ad(i) = con_ad(i)-d2c_ad(i)*(sigma(i)+tau(i))
          d2c_ad(i) = 0.
        end do
      endif
      do i = 1, ni
        con_ad(i) = con_ad(i)+crd_ad(i)
        crd_ad(i) = 0.
        con_ad(i) = con_ad(i)+cld_ad(i)
        cld_ad(i) = 0.
      end do
      do i = 2, ni-2
        con_ad(i+1) = con_ad(i+1)+cm_ad(i+1)*lambda(i)
        con_ad(i) = con_ad(i)+cm_ad(i+1)*(1-lambda(i))
        dc_ad(i+1) = dc_ad(i+1)-cm_ad(i+1)*mu(i)
        dc_ad(i) = dc_ad(i)+cm_ad(i+1)*nu(i)
        cm_ad(i+1) = 0.
      end do
      do i = 2, ni-1
        dc(i) = chi(i)*(con(i+1)-con(i))+psi(i)*(con(i)-con(i-1))
        if ((con(i+1)-con(i))*(con(i)-con(i-1)) .gt. 0.) then
          con_ad(i+1) = con_ad(i+1)+2.*dc_ad(i)*(0.5-sign(0.5,2.*abs(con(i+1)-con(i))-abs(dc(i))))*sign(1.,con(i+1)-con(i))*sign(1.,
     $dc(i))
          con_ad(i) = con_ad(i)-2.*dc_ad(i)*(0.5-sign(0.5,2.*abs(con(i+1)-con(i))-abs(dc(i))))*sign(1.,con(i+1)-con(i))*sign(1.,
     $dc(i))
          dc_ad(i) = dc_ad(i)*(0.5+sign(0.5,2.*abs(con(i+1)-con(i))-abs(dc(i))))*sign(1.,dc(i))*sign(1.,dc(i))
        else
          dc_ad(i) = 0.
        endif
        con_ad(i-1) = con_ad(i-1)-dc_ad(i)*psi(i)
        con_ad(i+1) = con_ad(i+1)+dc_ad(i)*chi(i)
        con_ad(i) = con_ad(i)+dc_ad(i)*((-chi(i))+psi(i))
        dc_ad(i) = 0.
      end do
      con_ad(ni-1) = con_ad(ni-1)+cm_ad(ni)*(ds(ni)/(ds(ni-1)+ds(ni)))
      con_ad(ni) = con_ad(ni)+cm_ad(ni)*(ds(ni-1)/(ds(ni-1)+ds(ni)))
      cm_ad(ni) = 0.
      con_ad(2) = con_ad(2)+cm_ad(2)*(ds(1)/(ds(1)+ds(2)))
      con_ad(1) = con_ad(1)+cm_ad(2)*(ds(2)/(ds(1)+ds(2)))
      cm_ad(2) = 0.
      con_ad(ni) = con_ad(ni)+cm_ad(ni+1)
      cm_ad(ni+1) = 0.
      con_ad(1) = con_ad(1)+cm_ad(1)
      cm_ad(1) = 0.

      end subroutine vppm_ad


